import java.util.ListIterator;
import java.util.Stack;

public final class Clean {

    private final static Node expandNode
	(
	 Node n
	 )
    {
	int t = n.getTag();
	n.setTag(Tag.empty);
	Node n2 = null;

	int color = Tag.getColor(t) ;
	if(color != -1){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.setColor(Tag.empty, color));
	    }else{
		n2 = new Node(Tag.setColor(Tag.empty, color));
		n2.add(n);
	    }
	    n = n2 ;
	}

	int size = Tag.getSize(t);
	if(size != -1){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.setSize(Tag.empty, size));
	    }else{
		n2 = new Node(Tag.setSize(Tag.empty, size));
		n2.add(n);
	    }
	    n = n2 ;
	}

	if (Tag.isU3(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.u3);
	    }else{
		n2 = new Node(Tag.u3);
		n2.add(n);
	    }
	    n = n2 ;    
	}

	if (Tag.isU2(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.u2);
	    }else{
		n2 = new Node(Tag.u2);
		n2.add(n);
	    }
	    n = n2 ;
	}

	if (Tag.isU1(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.u1);
	    }else{
		n2 = new Node(Tag.u1);
		n2.add(n);
	    }
	    n = n2 ;
	}

	if (Tag.isTt(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.tt);
	    }else{
		n2 = new Node(Tag.tt);
		n2.add(n);
	    }
	    n = n2 ;
	}

	if (Tag.isS(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.s);
	    }else{
		n2 = new Node(Tag.s);
		n2.add(n);
	    }
	    n = n2 ;
	}
	    
	if (Tag.isI(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.i);
	    }else{
		n2 = new Node(Tag.i);
		n2.add(n);
	    }
	    n = n2 ;
	}
	    
	if (Tag.isEm(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.em);
	    }else{
		n2 = new Node(Tag.em);
		n2.add(n);
	    }
	    n = n2 ;
	}
	    
	if (Tag.isB(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.b);
	    }else{
		n2 = new Node(Tag.b);
		n2.add(n);
	    }
	    n = n2 ;
	}
	    
	if (Tag.isPl(t)){
	    if(n2 == null){
		n2 = n ;
		n2.setTag(Tag.pl);
	    }else{
		n2 = new Node(Tag.pl);
		n2.add(n);
	    }
	    n = n2 ;
	}

	return n ;

    }

    public final static Node uncombineTags
	(
	 Node n
	 )
    {
	int tag = n.getTag();

	if(n.isString()) {
	    return n ;
	} else {
	    ListIterator children = n.getSubtrees() ;
	    Node ch ;
	    Node ch2 ;
	    while(children.hasNext()){
		ch = (Node) children.next();
		ch2 = uncombineTags(ch);

		if(ch != ch2){
		    children.remove();
		    children.add(ch2);
		}
		
	    }

	    return expandNode(n);

	}
	
    }


    private static Stack newCh = null ;

    private final static boolean recClean
	(
	 Node n,
	 int context
	 )
    {
	if(n.isString()) {
	    return false ;
	} else {
	    int tag = n.getTag();
	    int newContext = Tag.composeOntoContext(context, tag);
	    ListIterator children = n.getSubtrees() ;

	    /* If this is an old context, shove children onto
	       newCh, after cleaning them.  In this way, each
	       orphaned child is copied only once in the event of
	       a large chain of dead nodes, like
	       <B><B><B>lots of stuff</B></B></B>
	       Nodes are copied out only upon reaching their final
	       destination.
	    */	      
	    if(newContext == context){
		while(children.hasNext()){
		    newCh.push((Node) children.next());
		}

		return true ;

	    }else{
		boolean hasChildren = false ;

		while(children.hasNext()){
		    if(recClean((Node) children.next(), newContext)){
			children.remove();
			Stack temp = new Stack();
			temp.ensureCapacity(newCh.size());

			// all these orphans have found a home.
			// copy them into this, their final resting place.
			while(! newCh.empty()){
			    temp.push(newCh.pop());
			}

			while(! temp.empty()){
			    Node n2 = (Node) temp.pop();
			    if(! recClean(n2, newContext)){
				children.add(n2);
				hasChildren = true ;
			    }else{
				while(! newCh.empty()){
				    temp.push(newCh.pop());
				}
			    }
			}

		    }else{
			hasChildren = true ;
		    }
		}
		
		return ! hasChildren ;
	    }

	}
	
    }


    public final static Node clean
	(
	 Node n
	 )
    {
	newCh = new Stack();

	if(n.getTag() != Tag.empty){
	    Node n2 = new Node(Tag.empty);
	    n2.add(n);
	    n = n2 ;
	}

	ListIterator children = n.getSubtrees();

	// copied right from recClean
	while(children.hasNext()){
	    if(recClean((Node) children.next(), Tag.topLevel)){
		children.remove();
		Stack temp = new Stack();
		temp.ensureCapacity(newCh.size());
		
		while(! newCh.empty()){
		    temp.push(newCh.pop());
		}
		
		while(! temp.empty()){
		    Node n2 = (Node) temp.pop();
		    if(! recClean(n2, Tag.topLevel)){
			children.add(n2);
		    }else{
			while(! newCh.empty()){
			    temp.push(newCh.pop());
			}
		    }
		}
		
	    }
	}

	return n ;

    }


}



