import java.util.Stack;
import java.util.Map;
import java.util.HashMap;
import java.util.ListIterator;

// would probably be good to optimize things so that usually it
// looks at the parent, e.g. keep the singleton fields accurate

// leading edge children can be pushed onto anything this node can be pushed onto

// *************!!!!
// ideally, would make this into a loop s.t. dummy returns are ignored
// also, can do stuff like how you can hoist multiple things up, just not
// so that newer ones are higher than older ones.
// *************!!!!

// could probably add in trailing-edge hoisting here somehow, too.

// first write head hoisting.  then try to integrate tail hoisting.  if can't, write tail hoist.

// eventually want to make this be able to deal with supertags nicely (by node splitting)

final public class Hoist {
    static int depth ;
    static private Stack hoists ;

    final static private class HoistData {
	public HoistData
	    (
	     int d,
	     Node n
	     )
	{
	    depth = d ;
	    node = n ;
	}

	int depth ;
	Node node ;
    }

    final static private boolean haveHoistsToHere
	(
	 int hereDepth
	 )
    {
	return
	    ! hoists.empty() &&
	    ((HoistData) hoists.peek()).depth == hereDepth ;
    }

    // This method implements idempotent top-down hoisting
    final static private boolean recHoist
	(
	 HashMap hdata,
	 Node n,
	 int context,
	 int minHoistDepth
	 )
    {
	if(! n.isString()){
	    int newContext = Tag.composeOntoContext(context, n.getTag()) ;
	    ListIterator children = n.getSubtrees();
	    Integer hoistToDepth = (Integer) hdata.get(new Integer(newContext));

	    if(hoistToDepth == null || hoistToDepth.intValue() < minHoistDepth){
		// new state.  add self to context, and recurse.
		boolean noChildren = true ;

		hdata.put(new Integer(newContext), new Integer(depth));
		depth++ ;

		while(children.hasNext()){
		    if(recHoist(hdata, (Node) children.next(), newContext, minHoistDepth)){
			children.remove();
			if(! hoists.empty()){
			    minHoistDepth = ((HoistData) hoists.peek()).depth ;
			}
		    }else{
			noChildren = false ;
			minHoistDepth = depth - 1 ;
			if(haveHoistsToHere(depth - 1)){
			    children.previous();			
			}
		    }

		    // add everything being hoisted to the current depth
		    while(haveHoistsToHere(depth - 1)){
			noChildren = false ;
			children.add(((HoistData) hoists.pop()).node);
			children.previous();
		    }
	
		}

		if(hoistToDepth == null){
		    hdata.remove(new Integer(newContext));
		}else{
		    // put back the old value
		    hdata.put(new Integer(newContext), hoistToDepth);
		}
		depth-- ;

		return noChildren ;

	    }else{
		// old state.  hoist all children, then kill self.
		while(children.hasNext()){
		    hoists.push(new HoistData(hoistToDepth.intValue(), (Node) children.next()));
		}

		return true ;

	    }

	}else{
	    // this is a string node, don't do anything
	    return false ;
	}

    }


    final static public Node hoist
	(
	 Node n
	 )
    {
	HashMap hdata = new HashMap();
	depth = 0 ;
	hoists = new Stack ();

	if(n.getTag() != Tag.empty){
	    // create a new empty node for things to be lifted into
	    Node n2 = new Node(Tag.empty);
	    n2.add(n);
	    n = n2 ;
	}

	recHoist(new HashMap(), n, Tag.topLevel, depth);

	return n ;

    }


}
