import java.util.ListIterator;

public final class Peephole {

    private static ListIterator addFirst;
    private static ListIterator addSecond;

    private static ListIterator peep_(Node n, int context)
    {
	if(!n.isString()) {
	    
	    int tag = n.getTag();
	    int newcontext = Tag.composeOntoContext(context, tag);
 
	    boolean lookForPL = tag == Tag.bitSetOnly(tag);

	    ListIterator iter = n.getSubtrees();

	    /* complicated */
	    
	    while(iter.hasNext()) {
		Node sub = (Node) (iter.next());
		int numToSub = 0;

		ListIterator toAdd = peep_(sub, newcontext);
		if(toAdd != null) {
		    int i=0, j;
		    while(toAdd.hasNext()) {
			iter.add(toAdd.next());
			numToSub++;
			toAdd.remove();
		    }
		}
		
		if(lookForPL && Tag.isPl(sub.getTag())
		   && Tag.composeOntoContext(newcontext, Tag.pl) == context) {

		    /* go destroy PL's position */
		    int i;
		    for(i=0; i<numToSub; ++i) {
			iter.previous();
		    }
		    iter.previous();
		    iter.remove();
		    for(i=0; i<numToSub; ++i) {
			iter.next();
		    }

		    int numToAdd=0;

		    /* take over PL node */
		    sub.setTag(Tag.empty);
		    iter.add(sub);

		    /* put everything past the PL in a new node */
		    Node after = new Node(tag);
		    while(iter.hasNext()) {
			after.add((Node) (iter.next()));
			iter.remove();
		    }
		    iter.add(after);

		    iter.previous();
		    iter.previous();

		    return iter;
		}
	    }
	}
	return null;
    }

    public static void peep(Node n)
    {
	peep_(n, 0);
    }
}
